summaryrefslogtreecommitdiff
path: root/tests/misc/sort-compress.sh
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-08-30 14:13:12 +0200
committerJim Meyering <meyering@redhat.com>2012-08-30 18:55:59 +0200
commit9eb4c31eb78c28dd9f72d1cbb940270311be343c (patch)
treeea3078bc1b002a9f948ed41445ca32318002a1d3 /tests/misc/sort-compress.sh
parent00f5ba15dd91a3d9780fe1fbd06a4df436ae6714 (diff)
downloadcoreutils-9eb4c31eb78c28dd9f72d1cbb940270311be343c.tar.xz
tests: add .sh and .pl suffixes to shell and perl tests, respectively
Not only this shrinks the size of the generated Makefile (from > 6300 lines to ~3000), but will allow further simplifications in future changes. * tests/Makefile.am (TEST_EXTENSIONS): Add '.sh' and '.pl'. (PL_LOG_COMPILER, SH_LOG_COMPILER): New, still defined simply to $(LOG_COMPILER) for the time being. (TESTS, root_tests): Adjust as described. * All tests: Rename as described.
Diffstat (limited to 'tests/misc/sort-compress.sh')
-rwxr-xr-xtests/misc/sort-compress.sh72
1 files changed, 72 insertions, 0 deletions
diff --git a/tests/misc/sort-compress.sh b/tests/misc/sort-compress.sh
new file mode 100755
index 000000000..00dcf06ac
--- /dev/null
+++ b/tests/misc/sort-compress.sh
@@ -0,0 +1,72 @@
+#!/bin/sh
+# Test use of compression by sort
+
+# Copyright (C) 2007-2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ sort
+
+seq -w 2000 > exp || framework_failure_
+tac exp > in || framework_failure_
+
+# This should force the use of temp files
+sort -S 1k in > out || fail=1
+compare exp out || fail=1
+
+# Create our own gzip program that will be used as the default
+cat <<\EOF > gzip || fail=1
+#!/bin/sh
+tr 41 14
+touch ok
+EOF
+
+chmod +x gzip
+
+# Ensure 'sort' is immune to parent's SIGCHLD handler
+# Use a subshell and an exec to work around a bug in FreeBSD 5.0 /bin/sh.
+(
+ # ash doesn't support "trap '' CHLD"; it knows only signal numbers.
+ sig=$("$abs_top_builddir/src/kill" -l CHLD 2>/dev/null) && trap '' $sig
+
+ # This should force the use of child processes for "compression"
+ PATH=.:$PATH exec sort -S 1k --compress-program=gzip in > /dev/null
+) || fail=1
+
+# This will find our new gzip in PATH
+PATH=.:$PATH sort -S 1k --compress-program=gzip in > out || fail=1
+compare exp out || fail=1
+test -f ok || fail=1
+rm -f ok
+
+# This is to make sure it works with no compression.
+PATH=.:$PATH sort -S 1k in > out || fail=1
+compare exp out || fail=1
+test -f ok && fail=1
+
+# This is to make sure we can use something other than gzip
+mv gzip dzip || fail=1
+sort --compress-program=./dzip -S 1k in > out || fail=1
+compare exp out || fail=1
+test -f ok || fail=1
+rm -f ok
+
+# Make sure it can find other programs in PATH correctly
+PATH=.:$PATH sort --compress-program=dzip -S 1k in > out || fail=1
+compare exp out || fail=1
+test -f ok || fail=1
+rm -f dzip ok
+
+Exit $fail